
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ this file was originally created for testing my disassembler... you may take this
    @ as a quick reference if you are wondering whats the correct syntax for GAS
    @ 2/4/2002 groepaz/hitmen (groepaz@gmx.net)
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    .global _start

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ 16 bit section !
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    .text
    .align 2
    .code 16

    @ (long) branch with link
t11:    bl t13
t12:    bl t13
    .thumb_func
t13:    bl t13
t14:    bl t13
t15:    bl t13
t16:    bl t13

    .ltorg

    @ unconditional branch
t2:    b  t4
t3:    b  t4
    .thumb_func
t4:    b  t4
t5:    b  t4
t6:    b  t4
t7:    b  t4

    .ltorg

t32:    beq t34
t33:    beq t34
    .thumb_func
t34:    beq t34
t35:    beq t34
t36:    beq t34
t37:    beq t34

    .ltorg

    @ system call
    swi 0
    swi 1
    swi 2
    swi 3
    swi 4

    @ load/store multiple, post-indexed, writeback
    ldmia r0!,{r0-r7}
    stmia r0!,{r0-r7}
    ldmia r1!,{r1-r6}
    stmia r1!,{r1-r6}
    ldmia r2!,{r2-r5}
    stmia r2!,{r2-r5}

    @ push/pop registers to/from stack
    push {r0-r7}
    pop  {r0-r7}

    @ push/pop registers to/from stack including pc/lr
    push {r0-r7,lr}
    pop  {r0-r7,pc}

    @ add offset to stackpointer
    add sp,#0x10
    add sp,#-0x10

    @ load address

    adr r0,t9
t9:

    add r0,pc,#0x10
@    add r0,pc,#-0x10
    add r0,sp,#0x10
@    add r0,sp,#-0x10

    @ sp-relative load/store
    ldr r0,[sp,#0x10]
    str r0,[sp,#0x10]

    @ load/store halfword
    ldrh r0,[r1,#0x10]
    strh r0,[r1,#0x10]

    @ load/store with immediate offset
    ldr  r0,[r1,#0x10]
    str  r0,[r1,#0x10]
    ldrb r0,[r1,#0x10]
    strb r0,[r1,#0x10]

    @ load/store sign extended byte/halfword
    ldrh  r0,[r1,r2]
    strh  r0,[r1,r2]
    ldsb  r0,[r1,r2]
    ldsh  r0,[r1,r2]

    @ load/store byte/word with register offset
    ldr   r0,[r1,r2]
    str   r0,[r1,r2]
    ldrb  r0,[r1,r2]
    strb  r0,[r1,r2]

    @ load pc-relative
    ldr  r0,=0xdeadbeaf
    ldr  r0,[pc,#0x10]

    @ Hi register operations/branch exchange
t52:    bx  r0
t53:    bx  r15

    ADD r0, r15
    ADD r15, r0
    ADD r15, r14

    CMP r0, r15
    CMP r15, r0
    CMP r15, r14

    MOV r0, r15
    MOV r15, r0
    MOV r15,r14

    @ immediate mov/cmp/add/sub
    MOV r1, #0x10
    CMP r1, #0x10
    ADD r1, #0x10
    SUB r1, #0x10

    @ move shifted register
    lsl r0, r1, #0x10
    lsr r0, r1, #0x10
    asr r0, r1, #0x10

    @ add/substract
    add r0, r1, r2
    add r0, r1, #0x02
    sub r0, r1, r2
    sub r0, r1, #0x02

    @ ALU operations

    AND R0, R1
    EOR R0, R1
    LSL R0, R1
    LSR R0, R1
    ASR R0, R1
    ADC R0, R1
    SBC R0, R1
    ROR R0, R1
    TST R0, R1
    NEG R0, R1
    CMP R0, R1
    CMN R0, R1
    ORR R0, R1
    MUL R0, R1
    BIC R0, R1
    MVN R0, R1

    .ltorg

    .text
    .code 32
    .align 4

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ _start must be in 32 bit section !
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

_start:

    @ system call
    swi 0
    swi 1
    swi 2
    swi 3
    swi 4


    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ PSR Transfer (MRS, MSR)
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ MRS (transfer PSR contents to a register)

    mrs r0,cpsr
    mrs r0,spsr

    @ MSR (transfer register contents to PSR)

    msr cpsr,r0
    msr spsr,r0

    @ MSR (transfer register contents or immdiate value to PSR flag bits only)

    msr cpsr_f,r0
    msr spsr_f,r0

    @ The expression should symbolise a 32 bit value of which the most significant
    @ four bits are written to the N,Z,C and V flags respectively.
    @ msr cpsr_f,#0x0f,ror #04
    @ msr spsr_f,#0x0f,ror #04
    msr cpsr_f,#0xf0000000
    msr spsr_f,#0xf0000000

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ JUMPS
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

_t1:    b  _t4
_t2:    b  _t4
_t3:    b  _t4
_t4:    b  _t4
_t5:    b  _t4
_t6:    b  _t4
_t7:    b  _t4

    @ branch with link
    bl _start

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ branch and exchange cpu-mode
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    bx r0

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ data processing instructions
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ MOV,MVN (single operand instructions.)
    @ <opcode>{cond}{S} Rd,<Op2>
    @ CMP,CMN,TEQ,TST (instructions which do not produce a result.)
    @ <opcode>{cond} Rn,<Op2>
    @ AND,EOR,SUB,RSB,ADD,ADC,SBC,RSC,ORR,BIC (double operand instructions.)
    @ <opcode>{cond}{S} Rd,Rn,<Op2>
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ MOV r0,r0,#0x00 ROR #0x00
    @ (op2 immediate)
    mov r0,#0x11
    @ MOV r0,r0,r1 LSL r2
    @ (op2 register, shift register)
    mov r0,r1, lsl r2
    @ MOV r0,r0,r1 LSL r2
    @ (op2 register, shift immediate)
    mov r0,r1, lsl #0x11

    @ MOVS r0,r0,#0x00 ROR #0x00
    @ (op2 immediate)
    movs r0,#0x11
    @ MOVS r0,r0,r1 LSL r2
    @ (op2 register, shift register)
    movs r0,r1, lsl r2
    @ MOVS r0,r0,r1 LSL #0x11
    @ (op2 register, shift immediate)
    movs r0,r1, lsl #0x11

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ Load R0 with the word addressed by R2, and store R1 at R2.
    @ r0=[r2], [r2]=r1
    swp R0,R1,[R2]
    @ Load R2 with the byte addressed by R4, and store bits 0 to 7 of R3 at R4.
    swpb R2,R3,[R4]
    @ Conditionally swap the contents of the word addressed by R1 with R0.
    swpeq  R0,R0,[R1]
    @ Conditionally swap the contents of the byte addressed by R1 with R0.
    swpeqb R0,R0,[R1]

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ MUL{cond}{S} Rd,Rm,Rs
    @ MLA{cond}{S} Rd,Rm,Rs,Rn
    @
    @ {cond} two-character condition mnemonic.
    @ {S} set condition codes if S present
    @ Rd, Rm, Rs and Rn are expressions evaluating to a register number other than R15.
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ R1:=R2*R3
    MUL R1,R2,R3
    @ Conditionally R1:=R2*R3+R4, setting condition codes.
    MLAEQS R1,R2,R3,R4

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ UMULL{cond}{S} RdLo,RdHi,Rm,Rs
    @   Unsigned Multiply Long 32 x 32 = 64
    @ UMLAL{cond}{S} RdLo,RdHi,Rm,Rs
    @   Unsigned Multiply & Accumulate Long 32 x 32 + 64 = 64
    @ SMULL{cond}{S} RdLo,RdHi,Rm,Rs
    @   Signed Multiply Long 32 x 32 = 64
    @ SMLAL{cond}{S} RdLo,RdHi,Rm,Rs
    @   Signed Multiply & Accumulate Long 32 x 32 + 64 = 64
    @
    @ {cond} two-character condition mnemonic.
    @ {S} set condition codes if S present
    @ RdLo, RdHi, Rm, Rs are expressions evaluating to a register number other than R15.
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ R4,R1:=R2*R3
    UMULL R1,R4,R2,R3
    @ R5,R1:=R2*R3+R5,R1 also setting condition codes
    UMLALS R1,R5,R2,R3
    @ conditionally signed R5,R1:=R2*R3+R5,R1 also setting condition codes
    SMLALEQS R1,R5,R2,R3

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ LDR|STR>{cond}{B}{T} Rd,<Address>
    @
    @    LDR load from memory into a register
    @    STR store from a register into memory
    @    {cond} two-character condition mnemonic.
    @    {B} if B is present then byte transfer, otherwise word transfer
    @    {T} if T is present the W bit will be set in a post-indexed instruction, forcing
    @        non-privileged mode for the transfer cycle. T is not allowed when a
    @        pre-indexed addressing mode is specified or implied.
    @    Rd is an expression evaluating to a valid register number.
    @    Rn and Rm are expressions evaluating to a register number. If Rn is R15 then the
    @    assembler will subtract 8 from the offset value to allow for ARM7TDMI
    @    pipelining. In this case base write-back should not be specified.
    @
    @    <Address> can be:
    @    1 An expression which generates an address:
    @      <expression>
    @      The assembler will attempt to generate an instruction using
    @      the PC as a base and a corrected immediate offset to address
    @      the location given by evaluating the expression. This will be a
    @      PC relative, pre-indexed address. If the address is out of
    @      range, an error will be generated.
    @    2 A pre-indexed addressing specification:
    @      [Rn]                       offset of zero
    @      [Rn,<#expression>]{!}      offset of <expression> bytes
    @      [Rn,{+/-}Rm{,<shift>}]{!}  offset of +/- contents of index register,
    @                                 shifted by <shift>
    @    3 A post-indexed addressing specification:
    @      [Rn],<#expression>         offset of <expression> bytes
    @      [Rn],{+/-}Rm{,<shift>}     offset of +/- contents of index register,
    @                                 shifted as by <shift>.
    @
    @      <shift> general shift operation (see data processing instructions) but
    @      you cannot specify the shift amount by a register.
    @      {!} writes back the base register (set the W bit) if! is present.
    @
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ word, expression address
    ldr   r0,=_start
    str   r0,=_start
    @ byte, expression address
    ldrb  r0,=_start
    strb  r0,=_start

    @ word, no offset
    ldr   r0,[r1]
    str   r0,[r1]
    @ byte, no offset
    ldrb  r0,[r1]
    strb  r0,[r1]

    @ word, immediate offset, pre-indexed
    ldr   r0,[r1,#+0x11]
    ldr   r0,[r1,#-0x11]
    str   r0,[r1,#+0x11]
    str   r0,[r1,#-0x11]
    @ byte, immediate offset, pre-indexed
    ldrb  r0,[r1,#+0x11]
    ldrb  r0,[r1,#-0x11]
    strb  r0,[r1,#+0x11]
    strb  r0,[r1,#-0x11]
    @ word, immediate offset, pre-indexed, writeback
    ldr   r0,[r1,#+0x11] !
    ldr   r0,[r1,#-0x11] !
    str   r0,[r1,#+0x11] !
    str   r0,[r1,#-0x11] !
    @ byte, immediate offset, pre-indexed, writeback
    ldrb  r0,[r1,#+0x11] !
    ldrb  r0,[r1,#-0x11] !
    strb  r0,[r1,#+0x11] !
    strb  r0,[r1,#-0x11] !

    @ word, immediate offset, post-indexed
    ldr   r0,[r1],#+0x11
    ldr   r0,[r1],#-0x11
    str   r0,[r1],#+0x11
    str   r0,[r1],#-0x11
    @ byte, immediate offset, post-indexed
    ldrb  r0,[r1],#+0x11
    ldrb  r0,[r1],#-0x11
    strb  r0,[r1],#+0x11
    strb  r0,[r1],#-0x11
    @ word, immediate offset, post-indexed, writeback
    ldrt  r0,[r1],#+0x11
    ldrt  r0,[r1],#-0x11
    strt  r0,[r1],#+0x11
    strt  r0,[r1],#-0x11
    @ byte, immediate offset, post-indexed, writeback
    ldrbt r0,[r1],#+0x11
    ldrbt r0,[r1],#-0x11
    strbt r0,[r1],#+0x11
    strbt r0,[r1],#-0x11

    @ word, register offset, pre-indexed
    ldr   r0,[r1,+r2]
    ldr   r0,[r1,-r2]
    str   r0,[r1,+r2]
    str   r0,[r1,-r2]
    @ byte, register offset, pre-indexed
    ldrb  r0,[r1,+r2]
    ldrb  r0,[r1,-r2]
    strb  r0,[r1,+r2]
    strb  r0,[r1,-r2]
    @ word, register offset, pre-indexed, writeback
    ldr   r0,[r1,+r2] !
    ldr   r0,[r1,-r2] !
    str   r0,[r1,+r2] !
    str   r0,[r1,-r2] !
    @ byte, register offset, pre-indexed, writeback
    ldrb  r0,[r1,+r2] !
    ldrb  r0,[r1,-r2] !
    strb  r0,[r1,+r2] !
    strb  r0,[r1,-r2] !
    @ word, register offset, pre-indexed,            shift
    ldr   r0,[r1,+r2,lsr #0x11]
    ldr   r0,[r1,-r2,lsr #0x11]
    str   r0,[r1,+r2,lsr #0x11]
    str   r0,[r1,-r2,lsr #0x11]
    @ byte, register offset, pre-indexed,            shift
    ldrb  r0,[r1,+r2,lsr #0x11]
    ldrb  r0,[r1,-r2,lsr #0x11]
    strb  r0,[r1,+r2,lsr #0x11]
    strb  r0,[r1,-r2,lsr #0x11]
    @ word, register offset, pre-indexed, writeback, shift
    ldr   r0,[r1,+r2,lsr #0x11] !
    ldr   r0,[r1,-r2,lsr #0x11] !
    str   r0,[r1,+r2,lsr #0x11] !
    str   r0,[r1,-r2,lsr #0x11] !
    @ byte, register offset, pre-indexed, writeback, shift
    ldrb  r0,[r1,+r2,lsr #0x11] !
    ldrb  r0,[r1,-r2,lsr #0x11] !
    strb  r0,[r1,+r2,lsr #0x11] !
    strb  r0,[r1,-r2,lsr #0x11] !

    @ word, register offset, post-indexed
    ldr   r0,[r1],+r2
    ldr   r0,[r1],-r2
    str   r0,[r1],+r2
    str   r0,[r1],-r2
    @ byte, register offset, post-indexed
    ldrb  r0,[r1],+r2
    ldrb  r0,[r1],-r2
    strb  r0,[r1],+r2
    strb  r0,[r1],-r2
    @ word, register offset, post-indexed, writeback
    ldrt  r0,[r1],+r2
    ldrt  r0,[r1],-r2
    strt  r0,[r1],+r2
    strt  r0,[r1],-r2
    @ byte, register offset, post-indexed, writeback
    ldrbt r0,[r1],+r2
    ldrbt r0,[r1],-r2
    strbt r0,[r1],+r2
    strbt r0,[r1],-r2
    @ word, register offset, post-indexed,            shift
    ldr   r0,[r1],+r2,lsr #0x11
    ldr   r0,[r1],-r2,lsr #0x11
    str   r0,[r1],+r2,lsr #0x11
    str   r0,[r1],-r2,lsr #0x11
    @ byte, register offset, post-indexed,            shift
    ldrb  r0,[r1],+r2,lsr #0x11
    ldrb  r0,[r1],-r2,lsr #0x11
    strb  r0,[r1],+r2,lsr #0x11
    strb  r0,[r1],-r2,lsr #0x11
    @ word, register offset, post-indexed, writeback, shift
    ldrt  r0,[r1],+r2,lsr #0x11
    ldrt  r0,[r1],-r2,lsr #0x11
    strt  r0,[r1],+r2,lsr #0x11
    strt  r0,[r1],-r2,lsr #0x11
    @ byte, register offset, post-indexed, writeback, shift
    ldrbt r0,[r1],+r2,lsr #0x11
    ldrbt r0,[r1],-r2,lsr #0x11
    strbt r0,[r1],+r2,lsr #0x11
    strbt r0,[r1],-r2,lsr #0x11

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @ <LDR|STR>{cond}<H|SH|SB> Rd,<address>
    @
    @ LDR load from memory into a register
    @ STR Store from a register into memory
    @ {cond} two-character condition mnemonic.
    @ H Transfer halfword quantity
    @ SB Load sign extended byte (Only valid for LDR)
    @ SH Load sign extended halfword (Only valid for LDR)
    @ Rd is an expression evaluating to a valid register number.
    @
    @ <address> can be:
    @   1 An expression which generates an address:
    @   <expression>
    @     The assembler will attempt to generate an instruction using the PC as a base and a corrected immediate
    @     offset to address the location given by evaluating the expression. This will be a PC relative, pre-indexed
    @     address. If the address is out of range, an error will be generated.
    @   2 A pre-indexed addressing specification:
    @     [Rn] offset of zero
    @     [Rn,<#expression>]{!} offset of <expression> bytes
    @     [Rn,{+/-}Rm]{!} offset of +/- contents of index register
    @   3 A post-indexed addressing specification:
    @     [Rn],<#expression> offset of <expression> bytes
    @     [Rn],{+/-}Rm offset of +/- contents of index register.
    @     Rn and Rm are expressions evaluating to a register number.
    @     If Rn is R15 then the assembler will subtract 8 from the offset
    @     value to allow for ARM7TDMI pipelining. In this case base
    @     write-back should not be specified.
    @     {!} writes back the base register (set the W bit) if ! is present.
    @
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ expression address
    ldrh    r0,=_start
    strh    r0,=_start
    ldrsh   r0,=_start
@    strsh   r0,=_start
    ldrsb   r0,=_start
@    strsb   r0,=_start

    @ no offset
    ldrh    r0,[r1]
    strh    r0,[r1]
    ldrsh   r0,[r1]
@    strsh   r0,[r1]
    ldrsb   r0,[r1]
@    strsb   r0,[r1]

    @ immediate offset, pre-indexed
    ldrh  R3,[R4,#0x11]
    strh  R3,[R4,#0x11]
    ldrsh R3,[R4,#0x11]
    @strsh R3,[R4,#0x11]
    ldrsb R3,[R4,#0x11]
    @strsb R3,[R4,#0x11]

    @ immediate offset, pre-indexed, writeback
    ldrh  R3,[R4,#0x11] !
    strh  R3,[R4,#0x11] !
    ldrsh R3,[R4,#0x11] !
    @strsh R3,[R4,#0x11] !
    ldrsb R3,[R4,#0x11] !
    @strsb R3,[R4,#0x11] !

    @ immediate offset, post-indexed, (implied) writeback
    ldrh    r0,[r1],#+0x11
    ldrh    r0,[r1],#-0x11
    ldrsh   r0,[r1],#+0x11
    ldrsh   r0,[r1],#-0x11
    ldrsb   r0,[r1],#+0x11
    ldrsb   r0,[r1],#-0x11
    strh    r0,[r1],#+0x11
    strh    r0,[r1],#-0x11
@    strsh   r0,[r1],#+0x11
@    strsh   r0,[r1],#-0x11
@    strsb   r0,[r1],#+0x11
@    strsb   r0,[r1],#-0x11

    @ immediate offset, post-indexed, writeback
@    ldrh    r0,[r1],#+0x11 !
@    ldrh    r0,[r1],#-0x11 !
@    ldrsh   r0,[r1],#+0x11 !
@    ldrsh   r0,[r1],#-0x11 !
@    ldrsb   r0,[r1],#+0x11 !
@    ldrsb   r0,[r1],#-0x11 !
@    strh    r0,[r1],#+0x11 !
@    strh    r0,[r1],#-0x11 !
@    strsh   r0,[r1],#+0x11 !
@    strsh   r0,[r1],#-0x11 !
@    strsb   r0,[r1],#+0x11 !
@    strsb   r0,[r1],#-0x11 !

    @ register offset, pre-indexed
    ldrh  R3,[R4,+r2]
    strh  R3,[R4,+r2]
    ldrsh R3,[R4,+r2]
@    strsh R3,[R4,+r2]
    ldrsb R3,[R4,+r2]
@    strsb R3,[R4,+r2]

    @ register offset, pre-indexed, writeback
    ldrh  R1,[R2,-R3]!
    strh  R1,[R2,-R3]!
    ldrsh R1,[R2,-R3]!
@    strsh R1,[R2,-R3]!
    ldrsb R1,[R2,-R3]!
@    strsb R1,[R2,-R3]!

    @ register offset, post-indexed, (implied) writeback
    ldrh   r0,[r1],+r2
    ldrh   r0,[r1],-r2
    strh   r0,[r1],+r2
    strh   r0,[r1],-r2

    @ register offset, post-indexed, writeback
@    ldrht  r0,[r1],+r2
@    ldrht  r0,[r1],-r2
@    strht  r0,[r1],+r2
@    strht  r0,[r1],-r2

    .ltorg

    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    @
    @ <LDM|STM>{cond}<FD|ED|FA|EA|IA|IB|DA|DB> Rn{!},<Rlist>{^}
    @
    @ {cond} two character condition mnemonic.
    @ Rn is an expression evaluating to a valid register number
    @ <Rlist> is a list of registers and register ranges enclosed in {} (e.g. {R0,R2-R7,R10}).
    @ {!} if present requests write-back (W=1), otherwise W=0
    @ {^} if present set S bit to load the CPSR along with the PC, or force
    @     transfer of user bank when in privileged mode
    @
    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    @ pre-indexed
    ldmib r0,{r0-r15}
    ldmdb r0,{r0-r15}
    stmib r0,{r0-r15}
    stmdb r0,{r0-r15}

    @ post-indexed
    ldmia r0,{r0-r15}
    ldmda r0,{r0-r15}
    stmia r0,{r0-r15}
    stmda r0,{r0-r15}

    @ pre-indexed, writeback
    ldmib r0!,{r0-r15}
    ldmdb r0!,{r0-r15}
    stmib r0!,{r0-r15}
    stmdb r0!,{r0-r15}

    @ post-indexed, writeback
    ldmia r0!,{r0-r15}
    ldmda r0!,{r0-r15}
    stmia r0!,{r0-r15}
    stmda r0!,{r0-r15}

    @ pre-indexed, force psr
    ldmib r0,{r0-r15}^
    ldmdb r0,{r0-r15}^
    stmib r0,{r0-r15}^
    stmdb r0,{r0-r15}^

    @ post-indexed, force psr
    ldmia r0,{r0-r15}^
    ldmda r0,{r0-r15}^
    stmia r0,{r0-r15}^
    stmda r0,{r0-r15}^

    @ pre-indexed, writeback, force psr
    ldmib r0!,{r0-r15}^
    ldmdb r0!,{r0-r15}^
    stmib r0!,{r0-r15}^
    stmdb r0!,{r0-r15}^

    @ post-indexed, writeback, force psr
    ldmia r0!,{r0-r15}^
    ldmda r0!,{r0-r15}^
    stmia r0!,{r0-r15}^
    stmda r0!,{r0-r15}^

        .ltorg
