
/********************************************************************/
/*            GP32 System Calls                                      */
/********************************************************************/

#ifndef _GP32_SYSTEM_CALL_H_
#define _GP32_SYSTEM_CALL_H_

#ifdef __cplusplus
extern "C" {
#endif

#ifdef  __GNUC__
#define SystemCall(No)   asm ("SWI    "#No)
#else
#define SystemCall(No) __asm { SWI    No}
#endif

/*------------------------------------------------------------------*/
/*                   System Call No.                                */
/*------------------------------------------------------------------*/

/*------------------------------------------------------------------*/
/*                   Functions                                      */
/*------------------------------------------------------------------*/

typedef void (*tGpSurfaceSet)(GPDRAWSURFACE* ptgpds);
tGpSurfaceSet gpSurfaceSet;

tGpSurfaceSet* Init();

unsigned long GpSurfaceCreate (GPDRAWSURFACE* ptgpds, int gdflag);
void gpLcdEnable(void);
unsigned long gpKeyGet(void);

#ifdef __cplusplus
}      /* extern "C" */
#endif

#endif /* _GP32_SYSTEM_CALL_H */
