
#ifndef _DEBUG_C_
#define _DEBUG_C_

#include "gp32.h"

#include <stdarg.h>                       /* for the va-macro family */

/*
#include <stddef.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
*/

void dbgPrintf(char *format,...) {
va_list args;
char *string;

        string=(char*)malloc(0x100);

        va_start(args,format);
        vsprintf((char*)string,(char*)format,(va_list)args);
        va_end(args);

//        _SIOPrint(string);

        free(string);

}

/* ?!

extern void *_stack;
extern void *_stack_size;
extern void *_end;
extern void *_heap_size;
extern void *_heap_size;

extern void *_fbss;
extern void *_root;

*/

/*
 *   only accessable at asm-level:
 *
     text-section:

     start
     etext


     end

 */


/*
 *   on c-level
 */

/* text section */
extern void *_start;              /* arm */
extern void *_etext;              /* arm */

/* cpp stuff */
extern void *__CTOR_LIST__;       /* cygwin */
extern void *_CTOR_LIST__;        /* cygwin */

extern void *__ctors;             /* arm */
extern void *__ctors_end;         /* arm */

extern void *__DTOR_LIST__;       /* cygwin */
extern void *_DTOR_LIST__;        /* cygwin */

extern void *__dtors;             /* arm */
extern void *__dtors_end;         /* arm */

/* data section */
extern void *_data_start__;       /* cygwin */
extern void *_data_end__;         /* cygwin */

extern void *_bdata,_edata;       /* arm */

/* bss section */
extern void *_bss_start__;        /* cygwin */
extern void *_bss_end__;          /* cygwin */

extern void *_stack;              /* arm */

/* end */
extern void *end;                 /* cygwin, arm */
extern void *_end__;              /* cygwin */

void dbgPrintInfo(void) {

unsigned long all_start=0, all_end=0;
unsigned long text_start=0, text_end=0;
unsigned long data_start=0, data_end=0;
unsigned long bss_start=0, bss_end=0;
unsigned long stack_start=0, stack_end=0;

    all_start = (unsigned long)(&_start);

//    text_start = (unsigned long )(&_text_start__);
    text_start = (unsigned long)(&_start);
//    text_end = (unsigned long )(&_text_end__);
    text_end = (unsigned long)(&_etext);

    data_start = (unsigned long)(&_bdata);
//    data_start = (unsigned long )(&_data_start__);
//    data_end = (unsigned long )(&_data_end__);
    data_end = (unsigned long)(&_edata);

    bss_start = (unsigned long)(&_bss_start__);
    bss_end = (unsigned long)(&_bss_end__);

    stack_end = (unsigned long)(&_stack);

    all_end = (unsigned long)(&end);
//    all_end = (unsigned long)(&_end__);

    dbgPrintf("\nstart : %08X\n", all_start) ;
    dbgPrintf("text  : %08X - %08X = %08X (%ld) bytes\n",
            (int)text_start, (int)text_end, (int)(text_end-text_start), (int)(text_end-text_start)) ;
    dbgPrintf("data  : %08X - %08X = %08X (%ld) bytes\n",
            (int)data_start, (int)data_end, (int)(data_end-data_start), (int)(data_end-data_start)) ;
    dbgPrintf("bss   : %08X - %08X = %08X (%ld) bytes\n",
            (int)bss_start, (int)bss_end, (int)(bss_end-bss_start), (int)(bss_end-bss_start)) ;
    dbgPrintf("stack : %08X - %08X = %08X (%ld) bytes\n",
            (int)stack_start, (int)stack_end, (int)(stack_end-stack_start), (int)(stack_end-stack_start)) ;
    dbgPrintf("end   : %08X\n\n", (int)all_end) ;

}

void dbgInit(void) {

    dbgPrintInfo();

}

#endif












