
@********************************************************************
@*            GP32 system calls                                     *
@********************************************************************

                .INCLUDE "gp32.inc"

		.TEXT
                .CODE 32

@ registers a surface
@ r0=pointer to surface
@ int GpSurfaceCreate (GPDRAWSURFACE* ptgpds, int gdflag)

                .global GpSurfaceCreate
GpSurfaceCreate:
                STMDB sp!,{r1,r2,r3,lr}             @ save r1,r2,r3,lr on stack
                mov r1, #0x00       @ surface number
                mov r2, #0x01       @ sub function
                swi 0x8             @ {r0-r2}, {r0}
                LDMIA sp!,{r1,r2,r3,pc}             @ restore r1,r2,r3,pc from stack

@ turns lcd on
@ void gpLcdEnable();

                .global gpLcdEnable
gpLcdEnable:
                STMDB sp!,{r1,r2,r3,lr}             @ save r1,r2,r3,lr on stack
                mov r2, #0x03       @ sub function
                swi 0x8             @ {r2}
                LDMIA sp!,{r1,r2,r3,pc}             @ restore r1,r2,r3,pc from stack

@ gets entry point to gpSurfaceSet
@ void Init();
                .global Init
Init:
                STMDB sp!,{r1,r2,r3,lr}             @ save r1,r2,r3,lr on stack
                mov r0, #0x00          @ sub functiom
                swi 0xb
                LDMIA sp!,{r1,r2,r3,pc}             @ restore r1,r2,r3,pc from stack

@ reports keypad status
@ int gpKeyGet();
                .GLOBAL gpKeyGet
gpKeyGet:
                STMDB sp!,{r1,r2,r3,lr}             @ save r1,r2,r3,lr on stack
                mov r0, #0x01             @ sub function
                swi 0x10                  @ {r0}, {r0}
                LDMIA sp!,{r1,r2,r3,pc}             @ restore r1,r2,r3,pc from stack


